#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <string.h>

#define EEPROM_DEV "/sys/bus/i2c/devices/0-0051/eeprom"
#define OFFSET     100
#define EEPROM_SIZE (512 * 128)

int main(int argc, char *argv[]) {
	int fd_eep;
	int ret;
	char data[50] = "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAaa";
	char r_data[60];
	char ch = ' ';

	fd_eep = open(EEPROM_DEV, O_RDWR);
	if (fd_eep < 0) {
		perror("Open eeprom device fail");
		return fd_eep;
	}
	printf("Open %s successful\n", EEPROM_DEV);

	printf("'e': erase\n's': skip\n");
	if (getchar() == 'e') {
		for (ret = 0; ret < EEPROM_SIZE; ++ret) {
			if (write(fd_eep, &ch, 1) < 0) {
				perror("Write 0x00 to eeprom fail");
				return -1;
			}
		}
	}

	if (lseek(fd_eep, OFFSET, SEEK_SET) == -1) {
		perror("Reposition offset fail");
		return -1;
	}
	printf("Reposition offset to 128 successful\n");

	if ((ret = write(fd_eep, data, strlen(data))) < 0) {
		perror("Write data to eeprom fail");
		return -1;
	}
	printf("Write \"%s\" successful\n", data);

	if (lseek(fd_eep, OFFSET, SEEK_SET) == -1) {
		perror("Reposition offset fail");
		return -1;
	}
	printf("Reposition offset to 128 successful\n");
	
	ret = read(fd_eep, r_data, strlen(data));
	if (ret < 0) {
		perror("Read data from eeprom fail");
		return -1;
	}
	r_data[ret] = '\0';
	printf("Readed data is: %s\n", r_data);
	
	return 0;
}
	
