#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/ioctl.h>

#define LED_DEV "/dev/MYS-SAM9X5-ledtest" 
int main(int argc, char **argv)
{  
	int fd, ret, led_num, led_status;
	if (argc!=3 ||
		sscanf(argv[1],"%d", &led_num)!=1 ||
		sscanf(argv[2],"%d", &led_status)!=1) {
		printf("\r\nPlease input correct parameters !\r\n\n");
		printf("usage:\r\n%s <led_num> <led_status>\r\n", argv[0]);
		printf("\r\nOptions:\r\n");
		printf("  led_num\t-  1 for red led, 0 for blue led.\r\n  led_status\t-  1 for ON, 0 for OFF.\r\n\n");
		exit(1);   
	}

	if((led_status!=1 && led_status!=0) ||
		(led_num!=0 && led_num!=1)) {
		printf("\r\nError: The parameter value must be '0' or '1' !\r\n");
		printf("\r\nPlease try again !!! !\r\n\n");
		exit(1); 
	}

	/* Open led device */
	fd = open(LED_DEV, 0);
	if (fd < 0) {
		printf("\r\nFail to open device '%s'!\r\n\n", LED_DEV);
		exit(1);
	}

	/* Set led's status */
	ret = ioctl(fd, led_status, led_num);
	if(ret < 0) {
		printf("\r\nFail calling ioctl !\r\n\n");
	}
	
	close(fd);
	
	return 0;
}
