#include <stdio.h>
#include <stdlib.h>
#include <linux/rtc.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <termios.h>
#include <unistd.h>

int getch();

int main(int argc, char *argv[])
{
	int fd;
	struct rtc_time rtc_tm;

	fd = open("/dev/rtc", O_RDONLY);
	if (fd < 0) {
		perror("Error occured on open /dev/rtc");
		return 1;
	}

	while (1) {
		printf("Press any key to get rtc time('q' or 'Q' to exit):");
		if (getch() == 'q' || getch() == 'Q') {
			break;
		}
		
		if (ioctl(fd, RTC_RD_TIME, &rtc_tm) < 0) {
			perror("Error occured on get rtc time");
			return 1;
		}
		printf("\trtc time: %d sec, %d min, %d hour, %d day, %d mon, %d year\n",
			   rtc_tm.tm_sec,
			   rtc_tm.tm_min,
			   rtc_tm.tm_hour,
			   rtc_tm.tm_mday,
			   rtc_tm.tm_mon,
			   rtc_tm.tm_year + 1900);
	}

	printf("\n");
	
	close(fd);

	return 0;
}

int getch()
{
	struct termios tm, tm_old;
	int c, fd = STDIN_FILENO;

	if (tcgetattr(fd, &tm) < 0) {
		return -1;
	}

	tm_old = tm;
	cfmakeraw(&tm);

	if (tcsetattr(fd, TCSANOW, &tm) < 0) {
		return -1;
	}

	c = fgetc(stdin);

	if (tcsetattr(fd, TCSANOW, &tm_old) < 0) {
		return -1;
	}

	return c;
}
