#include "twi.h"

#define I2C_DEV     "/dev/i2c-0"
#define SLAVE_ADDR  0x51

#define BUF_SIZE    128

int main(int argc, char *argv[])
{
	char send_data[BUF_SIZE] = "This is test data, If reading this string, Testing is successful";
	char recv_data[BUF_SIZE] = { 0 };
	int  len = 0;
	int  addr = 0x80;

	printf("Initialize i2c device\n");
	if (i2c_init(I2C_DEV, SLAVE_ADDR) == FAILD) {
		printf("[info] Initialize i2c faild\n");
		return 1;
	}

	printf("Input write address:");
	scanf("%d", &addr);
	printf("Write data to eeprom 0x%x via I2C\n", addr);
	len = strlen(send_data);
	if (i2c_write(send_data, addr, &len) == FAILD) {
		printf("[info] Write data to eeprom faild\n");
		return 2;
	}

	sleep(1);

	printf("Read data from eeprom 0x%x via I2C\n", addr);
	len = BUF_SIZE - 1;
	if (i2c_read(recv_data, addr, BUF_SIZE, &len) == FAILD) {
		printf("[info] Read data from eeprom faild\n");
		return 3;
	}
	printf("Read content: %s\n", recv_data);
	
	return 0;
}
