#include <stdlib.h>
#include <stdio.h>

#ifdef _WIN32
#include <Windows.h>
#else
#include <unistd.h>
#endif

#include "rs232.h"

int main(int argc, char *argv[])
{
  	int i, n,
  	cport_nr = 1,        /* /dev/ttyS0 (COM1 on windows) */
  	bdrate = 9600;       /* 9600 baud */

	unsigned char buf[128] = "hello";

	if(OpenComport(cport_nr, bdrate))
	{
		printf("Can not open comport %s\n");

		return(0);
	}

	if (argv[1][0] == '1') {
		printf("Run as send mode\n"); 
		while (1) {
			n = SendBuf(cport_nr, buf, strlen(buf));
			if (n > 0) {
				printf("send %i bytes: %s\n", n, buf);
			}
			sleep(1);
		}
	}

	printf("Run as receiver mode\n");
	while(1)
	{
		n = PollComport(cport_nr, buf, 127);

		if(n > 0)
		{
			buf[n] = 0;   /* always put a "null" at the end of a string! */

			for(i=0; i < n; i++)
			{
				if(buf[i] < 32)  /* replace unreadable control-codes by dots */
				{
					buf[i] = '.';
				}
			}

			printf("received %i bytes: %s\n", n, (char *)buf);
        }

#ifdef _WIN32
		Sleep(100);  /* it's ugly to use a sleeptimer, in a real program, change the while-loop into a (interrupt) timerroutine */
#else
		sleep(1);  /* sleep for 100 milliSeconds */
#endif
    }

	return(0);
}
